<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

class modCommunityAllActionsHelper
{	
	function getArrangedData($actions, $limit = 10)
	{
		$to_select = array();
		foreach($actions as $act)
		{
			if (!key_exists($act->user_id, $to_select))
			{
				$to_select[$act->user_id] = $act;
			}
			if (count($to_select) == $limit)
			{
				break;
			}
		}
		return $to_select;
	}
	
	function getActivity( $params )
	{
		$db = JFactory::getDBO();
		/*$sql = "SELECT activ.*, u.id AS user_id, u.username, u.name, comm.title AS grouptitle, comm.id AS group_id"
				."\nFROM #__community_activity AS activ"
				."\nLEFT JOIN #__community_communities  AS comm ON comm.id = activ.client_id AND activ.client = 'community'"
				//."\nLEFT JOIN #__users AS u ON (u.id = activ.client_id AND activ.client = 'user') OR (u.id = activ.user_id AND activ.client = 'community') " 
				."\nGROUP BY (activ.id) ORDER BY activ.ctime DESC";*/
		$sql = "SELECT activ.*, comm.title AS grouptitle, comm.id AS group_id"
				."\nFROM #__community_activity AS activ"
				."\nLEFT JOIN #__community_communities  AS comm ON comm.id = activ.client_id AND activ.client = 'community'"
				//."\nLEFT JOIN #__users AS u ON (u.id = activ.client_id AND activ.client = 'user') OR (u.id = activ.user_id AND activ.client = 'community') " 
				."\nGROUP BY (activ.id) ORDER BY activ.ctime DESC";
		$db->setQuery( $sql );
		$result = $db->loadObjectList();
		
		$result = modCommunityAllActionsHelper::getArrangedData( $result, $params->get('activity_limit', 10) );
		/*
		echo "<pre>";
		echo $db->_sql;
		echo "</pre>";
		*/
		return 	$result;	
	}
	
	function getActivity_2 ( $users_id, $params )
	{
		if( count($users_id) < 1 ) return;
		
		$db = JFactory::getDBO();
		
		$sql = "SELECT activ.*, comm.title AS grouptitle, comm.id AS group_id"
				."\nFROM #__community_activity AS activ "
				."\nLEFT JOIN #__community_communities  AS comm ON comm.id = activ.client_id AND activ.client = 'community'"
				//."\nLEFT JOIN #__users AS u ON (u.id = activ.client_id AND activ.client = 'user') OR (u.id = activ.user_id AND activ.client = 'community') "
				."\nWHERE activ.user_id IN (".implode(',', $users_id).") "				
				."\nGROUP BY (activ.id) ORDER BY activ.ctime DESC";				
		$sql .= ($params->get('activity_limit', 0) != 0 ) ? " LIMIT 0, ". $params->get('activity_limit', 0) : "";
		$db->setQuery( $sql );
		$result = $db->loadObjectList();
		/*
		echo "<pre>";
		echo $db->_sql;
		echo "</pre>";
		*/
		return 	$result;	
	}
}
?>