<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

class modCommunityFriendsHelper
{
	function getFriendList( &$params )
	{
		$db			= & JFactory::getDBO();
		
		$user_id_1 	= JRequest::getInt('user_id', 0);
		$user_id_2	= & JFactory::getUser();
		
		// if user is showing itself
		if( $user_id_1 == $user_id_2->id || $user_id_1 == 0 )
			$user = & JFactory::getUser();
		else
			$user = & JFactory::getUser( intval($user_id_1) );
		
		$dispacher 	= &JDispatcher::getInstance();
		$lists		= array();		
		
		$query		= "SELECT u.friend_id, s.userid"
					  ."\n FROM #__users AS us"
					  ."\n LEFT JOIN #__community_userrelations AS u ON us.id = u.friend_id"
					  ."\n LEFT JOIN #__session AS s ON u.friend_id = s.userid AND s.client_id=0"
					  ."\n WHERE u.user_id={$user->id} AND u.status = 1"
					  ."\n GROUP BY u.friend_id ORDER BY RAND() ";
					  
		$query .= ($params->get('limit', 0)) ? " LIMIT 0,".$params->get('limit', 0) : "";
				
		$db->setQuery( $query );			

		$ids = $db->loadObjectList();
		$friends = NULL;
		$i = 0;		
		
		if( $ids ){
			
			foreach( $ids as $id )
			{		
				$friends[ $i ] = &JUser::getInstance( $id->friend_id );								
				$friends[ $i ]->setParam('online', (boolean) $id->userid, false );
													
				$dispacher->trigger('onRenderAvatar', array( &$friends[$i] ));
	  			$i++;
			}			
			return $friends;			
		}
		else return NULL;		
	 }
	
	function getFriendsOffline( &$params )
	{
	 	$db	= & JFactory::getDBO();
   		 
	 	$user_id_1 	= JRequest::getInt('user_id', 0);
		$user_id_2	= & JFactory::getUser();
		
		// if user is showing itself
		if( $user_id_1 == $user_id_2->id || $user_id_1 == 0)
			$user = & JFactory::getUser();
		else
			$user = & JFactory::getUser( intval($user_id_1) );
   		 
   		$dispacher	= &JDispatcher::getInstance();

   		$query		= 	"SELECT rel.friend_id "
						."\n FROM #__users AS u "
						."\n LEFT JOIN #__community_userrelations AS rel ON u.id = rel.friend_id"
						."\n WHERE rel.friend_id NOT IN "
						."\n ( SELECT sess.userid FROM #__session AS sess WHERE sess.client_id = 0 )"
						."\n AND rel.user_id = {$user->id} AND rel.status = 1 GROUP BY rel.friend_id ORDER BY RAND() ";
		$query .= ($params->get('limit', 0)) ? " LIMIT 0,".$params->get('limit', 0) : "";
				
		
   		 $db->setQuery($query);
   		 
   		 $ids = $db->loadResultArray();
   		 
   		 
   		 if ($db->getErrorNum()) {
			JError::raiseWarning( 500, $db->stderr() );
		 }
   		 
   		 $index = 0;
   		 $friendsoffline = NULL;
   		 if( count($ids) ){
	   		 foreach( $ids as $id )
	   		 {
	   		 	 $friendsoffline[ $index ] = JUser::getInstance($id);
	   		 	 $dispacher->trigger('onRenderAvatar', array( &$friendsoffline[ $index ]) );
	   		 	 $index++;
	   		 }
   		 }
   		 
   		 return $friendsoffline;
	 	
	 }
	 	 
   	function getUserName($id)
	{
		$db	=& JFactory::getDBO();
		$query="SELECT username FROM #__users WHERE id='$id' AND block=0";

		$db->setQuery($query, 0, 1);
		 return $result=$db->loadResult();
	 }
	 	 
   	function getFriendsOnline( &$params )
   	{
   		 $db	= & JFactory::getDBO();
   		 //$user	= & JFactory::getUser();
		 
		$user_id_1 	= JRequest::getInt('user_id', 0);
		$user_id_2	= & JFactory::getUser();
		
		// if user is showing itself
		if( $user_id_1 == $user_id_2->id || $user_id_1 == 0)
			$user = & JFactory::getUser();
		else
			$user = & JFactory::getUser( intval($user_id_1) );
		 
   		 $dispacher	= &JDispatcher::getInstance();
   		 $query =  "SELECT ur.friend_id, s.userid"
  				  ."\n FROM #__users AS u"
  				  ."\n LEFT JOIN #__community_userrelations AS ur ON ur.friend_id = u.id"
				  ."\n LEFT JOIN #__session AS s ON s.userid = ur.friend_id AND s.client_id = 0"
				  ."\n WHERE ur.user_id = {$user->id}"
				  ."\n AND ur.friend_id = s.userid AND ur.status = 1"
				  ."\n AND s.client_id = 0"
				  ."\n GROUP BY ur.friend_id ORDER BY RAND() ";
		$query .= ($params->get('limit', 0)) ? "LIMIT 0,".$params->get('limit', 0) : "";
				
   		 $db->setQuery($query);
   		 
   		 $ids = $db->loadResultArray();
   		 
   		 
   		 if ($db->getErrorNum()) {
			JError::raiseWarning( 500, $db->stderr() );
		 }
   		 
   		 $index = 0;
   		 $friendsonline = NULL;
   		 if( count($ids) ){
	   		 foreach( $ids as $id )
	   		 {
	   		 	 $friendsonline[ $index ] = JUser::getInstance($id);
	   		 	 $dispacher->trigger('onRenderAvatar', array( &$friendsonline[ $index ]) );
	   		 	 $index++;
	   		 }
   		 }
   		 
   		 return $friendsonline;
   	} 
}
