<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

class modCommunityGroupsHelper
{
	function getGroups( $user_id, $params )
	{
		$db =& JFactory::getDBO();
		
		$sort_by = $params->get('sort_by', 1);
		$order_by = $params->get('order_by', "ASC");
		
		$sql = "SELECT c.id, c.title, c.ctime, cat.title AS cat_title, cat.id AS cat_id"
				."\n FROM #__community_communities AS c "
				."\n LEFT JOIN #__community_user_mapping AS um ON c.id = um.group_id "
				#."\n LEFT JOIN #__categories AS cat ON c.catid = cat.id "
				."\n LEFT JOIN #__community_group_categories  AS cat ON c.catid = cat.id "
				."\n WHERE (um.user_id = {$user_id} OR c.user_id = {$user_id}) AND c.published=1"
				."\n GROUP BY c.id ";
				if( $sort_by == 1 ){
					$sql .= " ORDER BY RAND() ";	
				}
				else if( $sort_by == 2 ){ // category name
					$sql .= " ORDER BY cat.title ".$order_by; 
				}
				else if( $sort_by == 3 ){ // group title
					$sql .= " ORDER BY c.title ".$order_by;
				}				
				else  if( $sort_by == 4 ){ // creation date
					$sql .= " ORDER BY c.ctime ".$order_by;
				}
				else if( $sort_by == 5 ){ // members count
					$sql .= "ORDER BY c.num_users ".$order_by;
				}
				
		$sql .= ($params->get('limit', 0) != 0) ? "\n LIMIT 0,".$params->get('limit', 0) : "";
		
		$db->setQuery( $sql );
		//echo $db->_sql;
		$result = $db->loadObjectList();
		return $result;
	}
	
	function getAllGroups( $params )
	{
		$db =& JFactory::getDBO();
		
		$sort_by = $params->get('sort_by', 1);
		$order_by = $params->get('order_by', "ASC");
		
		$sql = "SELECT c.id, c.title, c.ctime, cat.title AS cat_title, cat.id AS cat_id"
				."\n FROM #__community_communities AS c "
				."\n LEFT JOIN #__community_user_mapping AS um ON c.id = um.group_id AND um.pending=0"
				."\n LEFT JOIN #__community_group_categories AS cat ON c.catid = cat.id "
				."\n WHERE c.published = 1 "
				."\n GROUP BY c.id ";
				
				if( $sort_by == 1 ){
					$sql .= " ORDER BY RAND() ";	
				}
				else if( $sort_by == 2 ){ // category name
					$sql .= " ORDER BY cat.title ".$order_by; 
				}
				else if( $sort_by == 3 ){ // group title
					$sql .= " ORDER BY c.title ".$order_by;
				}				
				else  if( $sort_by == 4 ){ // creation date
					$sql .= " ORDER BY c.ctime ".$order_by;
				}
				else if( $sort_by == 5 ){ // members count
					$sql .= "ORDER BY c.num_users ".$order_by;
				}		
		$sql .= ($params->get('limit', 0) != 0) ? "\n LIMIT 0,".$params->get('limit', 0) : "";		
		$db->setQuery( $sql );				
		//echo $db->_sql;
		$result =  $db->loadObjectList();
		return $result;
	}
}
?>